import vrml.*;
import vrml.field.*;
import vrml.node.*;

import vrml.Browser;

public class CalculateOffset extends Script {
    private float pos;
    private int ofs;

    private boolean enabled;
    private float Range = 0;
    private int Max = 0;
    private int Count = 0;
    private SFFloat range;
    private SFInt32 max;
    private SFInt32 count;
    private SFFloat position;
    private SFInt32 offset;

    public void initialize() {
        range = (SFFloat) getEventIn("range");
        max = (SFInt32) getEventIn("max");
        count = (SFInt32) getEventIn("count");
        position = (SFFloat) getEventOut("position");
        offset = (SFInt32) getEventOut("offset");
        pos = 0;
        ofs = 0;
        enabled = false;
    }

    public void processEvent(Event e) {
        if(e.getName().equals("point")) {
            if(enabled) {
              Browser.print("Set_point event has got !");
              try {
                float p = ((ConstSFVec3f) e.getValue()).getY();
                if (Count > Max && (p > 0 && p <= Range)) {
                    float i = (float) 2.0 / (Count - Max);
                    Browser.print("interval = " + i + ", Y = " + p);
                    ofs = (int) ((p / i) * (Range / 2));
                    Browser.print("Offset = " + ofs);
                    pos = (float) i * ofs;
                    Browser.print("Position = " + pos);
                    position.setValue(pos);
                    offset.setValue(ofs);
                }
/*
                else {
                    position.setValue(pos);
                    offset.setValue(ofs);
                }
*/
              }
              catch (Throwable ex) {
                Browser.print("Some exception has rised !");
              }
            }
        }
        else if(e.getName().equals("active")) {
            ConstSFBool a = (ConstSFBool) e.getValue();
            enabled = a.getValue();
        }
        else if(e.getName().equals("range")) {
            ConstSFFloat r = (ConstSFFloat) e.getValue();
            Range = r.getValue();
            Browser.print("Range = " + Range);
        }
        else if(e.getName().equals("max")) {
            ConstSFInt32 m = (ConstSFInt32) e.getValue();
            Max = m.getValue();
            Browser.print("Max = " + Max);
        }
        else if(e.getName().equals("count")) {
            ConstSFInt32 c = (ConstSFInt32) e.getValue();
            Count = c.getValue();
            Browser.print("Count = " + Count);
        }
    }
}
