// Copyright(C) 1998 Sergey Izvozchikov (lezdep@geocities.com)

// Class for encapsulating the file objects.
import java.lang.*;
import java.applet.*;
import vrml.external.field.*;
import vrml.external.exception.*;
import vrml.external.Node;
import vrml.external.Browser;

public class File extends Object {
  private boolean isOpen;
  public Node[] transArray;

  // EventIns we'll modify
  public EventInMFString fileNote;
  public EventInSFVec3f translation;

  // EventOuts we'll query
//  public EventOutSFTime fileTouchTime_changed;

  File(Browser browser, float x, float y, float z, String note)
  {
    try {
      transArray = browser.createVrmlFromString(
"EXTERNPROTO File [\n" + 
"             exposedField SFVec3f fileTranslation\n" + 
"             exposedField SFVec3f fileScale\n" + 
"             exposedField MFString fileNote\n" + 
"             eventOut SFBool fileOver\n" + 
"             eventOut SFTime fileTouchTime\n" + 
"] \"file.wrl#File\"\n\n" + 
"File {\n" +
"   fileTranslation " + x + " " + y + " " + z + "\n" +
"   fileNote \"" + note + "\"\n" +
"}\n"
);
    }
    catch (InvalidVrmlException e) {
      System.out.println("File Error: " + e);
    }
    isOpen = false;
  }

  void SetNote(String note) {
    String[] noteString = new String[1];
    noteString[0] = new String(note);
    try {
      fileNote = 
      (EventInMFString) transArray[0].getEventIn("fileNote");
      System.out.println(" \"fileNote\" EventIn has got !");
      fileNote.setValue(noteString);
    }
    catch (InvalidEventInException e) {
      System.out.println("File Error: " + e);
    }
  }

  void SetTransform(float x, float y) {
    try {
      translation = 
      (EventInSFVec3f) transArray[0].getEventIn("fileTranslation");
      System.out.println(" \"fileTranslation\" EventIn has got !");
      float[] position = new float[3];
      position[0] = x;
      position[1] = y;
      position[2] = 0;
      translation.setValue(position);
    }
    catch (InvalidEventInException e) {
      System.out.println("File Error: " + e);
    }
  }

  boolean IsOpen()
  {
    return isOpen;
  }

  void SetOpenState(boolean open)
  {
    if (isOpen != open)
      isOpen = open;
  }
}
