// Copyright(C) 1998 Sergey Izvozchikov (lezdep@geocities.com)

// Class for encapsulating the folder objects.
import java.lang.*;
import java.applet.*;
import vrml.external.field.*;
import vrml.external.exception.*;
import vrml.external.Node;
import vrml.external.Browser;

public class Folder extends Object {
  private boolean isOpen;
  public Node[] transArray;

  // EventIns we'll modify
  public EventInMFString folderNote;
  public EventInSFVec3f translation;

  // EventOuts we'll query
//  public EventOutSFTime folderTouchTime_changed;

  Folder(Browser browser, float x, float y, float z, String note)
  {
    try {
      transArray = browser.createVrmlFromString(
"EXTERNPROTO Folder [\n" + 
"             exposedField SFVec3f folderTranslation\n" + 
"             exposedField MFString noteString\n" + 
"             exposedField SFColor boxColor\n" + 
"             exposedField SFFloat boxTransparency\n" + 
"             exposedField SFVec3f boxScale\n" + 
"             eventOut SFBool folderOver\n" + 
"             eventOut SFTime folderTouchTime\n" + 
"] \"folder.wrl#Folder\"\n\n" + 
"Folder {\n" +
"   folderTranslation " + y + " " + x + " " + z + "\n" +
"   noteString \"" + note + "\"\n" +
"}\n"
);
    }
    catch (InvalidVrmlException e) {
      System.out.println("Folder Error: " + e);
    }
    isOpen = false;
  }

  void SetNote(String note) {
    String[] noteString = new String[1];
    noteString[0] = new String(note);
    try {
      folderNote = 
      (EventInMFString) transArray[0].getEventIn("noteString");
      System.out.println(" \"noteString\" EventIn has got !");
      folderNote.setValue(noteString);
    }
    catch (InvalidEventInException e) {
      System.out.println("Folder Error: " + e);
    }
  }

  void SetTransform(float x, float y) {
    try {
      translation = 
      (EventInSFVec3f) transArray[0].getEventIn("folderTranslation");
      System.out.println(" \"folderTranslation\" EventIn has got !");
      float[] position = new float[3];
      position[0] = x;
      position[1] = y;
      position[2] = 0;
      translation.setValue(position);
    }
    catch (InvalidEventInException e) {
      System.out.println("Folder Error: " + e);
    }
  }

  boolean IsOpen()
  {
    return isOpen;
  }

  void SetOpenState(boolean open)
  {
    if (isOpen != open)
      isOpen = open;
  }
}
