// Copyright(C) 1998 Sergey Izvozchikov (lezdep@geocities.com)

import java.net.*;
import java.io.*;
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.lang.Math;
import vrml.external.field.*;
import vrml.external.exception.*;
import vrml.external.Node;
import vrml.external.Browser;
import java.io.IOException;

import Folder;
import File;

class WaitingFrame extends Frame 
{
  TextField info;

  WaitingFrame() {
    super("Mail3D");
    add("Center", info = new TextField("Loading ... Please wait"));
    info.setEditable(false);
    pack();
  }
}

public class Mail3D extends Applet implements EventOutObserver {
  public static int FOLDERCOUNT = 6;
  public static int FILECOUNT = 10;
  public static int LINESIZE = 3;
  public static int MAILOFFSET = 1;
  public static int TEXTOFFSET = 2;
  public static int FOLDERSELECTED = 10;
  public static int FILESELECTED = 100;
  public static int MAXTEXTLINES = 8;

  String mainURL;
  String text[] = { 
      "From: master@nstu.rnd.su", 
	"Hello Master !", 
	"No attachments",
	"Line 1",
	"Line 2",
	"Line 3",
	"Line 4",
	"Line 5",
	"Line 6",
	"Line 7",
	"Line 8"
  };

  // Browser we're using
  Browser browser;

  Node Root;
  Node MailScroller;
  Node TextViewer;
  Node TextScroller;
  Node Note;
  Node[] Children;

  Folder[] Folders;
  int folderSelected;
  File[] Files;
  int fileSelected;

  // Common EventIn's and EventOut's
  EventInMFString viewerText;
  EventInMFString noteText;
  EventInSFInt32 mailCount;
  EventInSFInt32 textCount;
  EventOutSFInt32 Mail_offset_changed;
  EventOutSFInt32 Text_offset_changed;
  EventOutSFTime fileTouchTime;

  private String outStrings[];
  int ofs;

  public void init() {

/*
    String worldName[] = new String[1];
    worldName[0] = new String(getParameter("world_url"));
    String params[] = new String[1];
    params[0] = new String("world_url=" + worldName[0]);
*/

    // Initialaze output buffer

    //
    // Initialize connection to Cosmo Player
    //
    mainURL = (String) this.getCodeBase().toString();
    Folders = new Folder[Mail3D.FOLDERCOUNT];
    folderSelected = 0;
    Files = new File[Mail3D.FILECOUNT];
    fileSelected = 0;

    WaitingFrame waiting = new WaitingFrame();
    waiting.reshape(130, 90, 220, 160);
    waiting.show();
    try {
      System.out.println("Is trying to get Browser !");
      for (int i = 0; i < 10; i++) {
        browser = Browser.getBrowser(this);
        if (browser != null)
          break;
        Thread.sleep(500);
        System.out.println("Still trying to get Browser !");
      }
      if (browser == null) {
        System.out.println("Browser not available !");
        return;
      }
    //
    // Get handle to root of the scene graph
    //
      System.out.println("Is trying to get root Node !");
      for (int i = 0; i < 10; i++) {
        Root = browser.getNode("ROOT");
        if (Root != null)
          break;
        Thread.sleep(500);
        System.out.println("Still trying to get root Node !");
      }
      if (Root == null) {
        System.out.println("Root Node not available !");
        return;
      }
      MailScroller = browser.getNode("MAIL_SCROLL_POINTER");
      TextViewer = browser.getNode("TEXT_VIEWER");
      TextScroller = browser.getNode("TEXT_SCROLL_POINTER");
      Note = browser.getNode("NOTE_TEXT");
      Thread.sleep(3500);
// Set Mail Scroller ranges
      EventInSFInt32 max =
           (EventInSFInt32) MailScroller.getEventIn("scrollMax");
      max.setValue(Mail3D.FILECOUNT);
      EventInSFFloat range =
           (EventInSFFloat) MailScroller.getEventIn("scrollRange");
      range.setValue(4);
      mailCount =
           (EventInSFInt32) MailScroller.getEventIn("scrollCount");
      mailCount.setValue(10);
      Mail_offset_changed =
           (EventOutSFInt32) MailScroller.getEventOut("scrollOffset_changed");
      System.out.println(" \"scrollOffset\" EventIn from MailScroller has got !");
      Mail_offset_changed.advise(this, new Integer(Mail3D.MAILOFFSET));
// Set Text Scroller ranges
      max = (EventInSFInt32) TextScroller.getEventIn("scrollMax");
      max.setValue(Mail3D.MAXTEXTLINES);
      range = (EventInSFFloat) TextScroller.getEventIn("scrollRange");
      range.setValue(6);
      textCount = (EventInSFInt32) TextScroller.getEventIn("scrollCount");
      textCount.setValue(text.length);
      Text_offset_changed =
          (EventOutSFInt32) TextScroller.getEventOut("scrollOffset_changed");
      System.out.println(" \"scrollOffset\" EventIn from TextScroller has got !");
      Text_offset_changed.advise(this, new Integer(Mail3D.TEXTOFFSET));
// Set initial Message Text ! For debuging only !
      outStrings = new String[Mail3D.MAXTEXTLINES];
      ofs = 0;
      for(int i = ofs; i < Mail3D.MAXTEXTLINES + ofs; i++)
        outStrings[i - ofs] = text[i];
      viewerText = (EventInMFString)
          TextViewer.getEventIn("set_viewerText");
      System.out.println(" \"viewerText\" EventIn has got !");
      viewerText.setValue(outStrings);
      EventInMFNode nodesIn = (EventInMFNode)
        ((Node) browser.getNode("FOLDERS_ROOT")).getEventIn("addChildren");
      System.out.println(" \"addChildren\" EventIn from Folders Root has got !");
      for (int i = 0; i < (Mail3D.FOLDERCOUNT / Mail3D.LINESIZE); i++ )
        for (int j = 0; j < Mail3D.LINESIZE; j++ ) {
          int number = i * Mail3D.LINESIZE + j;
          Folders[number] = new Folder(browser, i, j, 0,
                                       "Folder #" + number);
          nodesIn.setValue(Folders[number].transArray);
          System.out.println("Folder #" + number);
        }
      Thread.sleep(3500);
      EventOutMFNode nodesOut = (EventOutMFNode)
        ((Node) browser.getNode("FOLDERS_ROOT")).getEventOut("children");
      System.out.println(" \"children\" EventOut from Folders Root has got !");
      Children = nodesOut.getValue();
      for (int i = 0; i < Children.length; i++ ) {
        EventOutSFTime folderTouchTime = (EventOutSFTime)
            Children[i].getEventOut("folderTouchTime");
        System.out.println(" \"folderTouchTime\" EventOut has got !");
        folderTouchTime.advise(this,
            new Integer(Mail3D.FOLDERSELECTED + i));
      }
/*
      nodesIn = (EventInMFNode)
        ((Node) browser.getNode("FILES_ROOT")).getEventIn("addChildren");
      System.out.println(" \"addChildren\" EventIn from Files Root has got !");
      for (int i = 0; i < Mail3D.FILECOUNT; i++ ) {
        Files[i] = new File(browser, 0, (float) (i * 0.4), 0,
                            "Message #" + i);
        nodesIn.setValue(Files[i].transArray);
        System.out.println("File #" + i);
      }
*/
      Thread.sleep(3500);
      nodesOut = (EventOutMFNode)
        ((Node) browser.getNode("FILES_ROOT")).getEventOut("children");
      System.out.println(" \"children\" EventOut from Files Root has got !");
      Children = nodesOut.getValue();
      for (int i = 0; i < Children.length; i++ ) {
        EventOutSFTime fileTouchTime = (EventOutSFTime)
            Children[i].getEventOut("fileTouchTime");
        System.out.println(" \"fileTouchTime\" EventOut has got !");
        fileTouchTime.advise(this, new Integer(Mail3D.FILESELECTED + i));
      }
    }
    catch (InterruptedException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (InvalidEventInException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (InvalidEventOutException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (IllegalArgumentException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (InvalidVrmlException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (InvalidNodeException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (NullPointerException e) {
      System.out.println("Mail3D Error: " + e);
    }
    catch (Throwable e) {
    }
    waiting.dispose();
  }

  public void callback(EventOut value, double timeStamp, 
                           Object data)
  {
    int action = ((Integer) data).intValue();
    if (action == Mail3D.MAILOFFSET) {
      System.out.println("Message #" + Mail_offset_changed.getValue()
				 + " has selected !");
    }
    else if (action == Mail3D.TEXTOFFSET) {
	int of = Mail3D.MAXTEXTLINES - Text_offset_changed.getValue();
      System.out.println(" Text offset has changed to " + of);
      if (of > 0 && of < (text.length - Mail3D.MAXTEXTLINES)) {
        if (ofs != of) {
          for(int i = of; i < Mail3D.MAXTEXTLINES + of; i++)
            outStrings[i - of] = text[i];
          viewerText.setValue(outStrings);
        }
        ofs = of;
      }
    }
    else if (action < Mail3D.FILESELECTED) { // FOLDERSELECTED
      int indx = action - Mail3D.FOLDERSELECTED;
      if (folderSelected != indx) { // New Folder has selected
        if (Folders[folderSelected].IsOpen()) {
          // Close Folder
//          Folders[folderSelected].Close();
//          Folders[folderSelected].SetOpenState(false);
          System.out.println(" Folder # " + folderSelected + " has closed ! ");
        }
        // Opening new Folder
        folderSelected = indx;
        if (! Folders[folderSelected].IsOpen()) {
          Folders[folderSelected].SetOpenState(true);
          System.out.println(" Folder # " + folderSelected
                             + " has opened ! ");
        }
        else {
          Folders[folderSelected].SetOpenState(false);
          System.out.println(" Folder # " + folderSelected
                             + " had already opened ! ");
        }
      }
      else {
        if (Folders[indx].IsOpen()) {
          Folders[indx].SetOpenState(false);
          System.out.println(" Folder # " + indx + " has closed ! ");
        }
        else {
          Folders[indx].SetOpenState(true);
          // Opening new Folder
          System.out.println(" Folder # " + indx + " has opened ! ");
        }
      }
      if (indx == 0) {
      try {
        EventInMFNode nodesIn = (EventInMFNode)
          ((Node) browser.getNode("FILES_ROOT")).getEventIn("removeChildren");
        EventOutMFNode nodesOut = (EventOutMFNode)
          ((Node) browser.getNode("FILES_ROOT")).getEventOut("children");
        Children = nodesOut.getValue();
//        for (int i = 0; i < Children.length; i++ ) {
//          nodesIn.setValue(Children[i]);
//        }
        nodesIn.setValue(Children);
      }
      catch (InvalidEventInException e) {
        System.out.println("Mail3D Error: " + e);
      }
      catch (InvalidEventOutException e) {
        System.out.println("Mail3D Error: " + e);
      }
      catch (IllegalArgumentException e) {
        System.out.println("Mail3D Error: " + e);
      }
      }
    }
    else { // FILESELECTED
      int indx = action - Mail3D.FILESELECTED;
      if (fileSelected != indx) { // New Message has selected
        Files[fileSelected].SetOpenState(false);
        fileSelected = indx;
        Files[fileSelected].SetOpenState(true);
        System.out.println(" New Message # " + indx + " has selected ! ");
      }
    }
  }
}
