import vrml.*;
import vrml.field.*;
import vrml.node.*;

public class ViewOffset extends Script {
    private int ofs;
    private boolean enabled;
    private SFInt32 max;
    private SFInt32 count;
    private MFString outString;
    private String inStrings[];
    private String outStrings[];

    public void initialize() {
        max = (SFInt32) getField("max");
        count = (SFInt32) getField("count");
        outString = (MFString) getEventOut("outString");
        ofs = 0;
        enabled = false;
        outStrings = null;
    }

    public void processEvent(Event e) {
        if(e.getName().equals("inString")) {
//            if(enabled) {
                ConstMFString s = (ConstMFString) e.getValue();
                inStrings = new String[s.getSize()];
                s.getValue(inStrings);
//            }
        }
        else if(e.getName().equals("active")) {
            ConstSFBool a = (ConstSFBool) e.getValue();
            enabled = a.getValue();
        }
        else if(e.getName().equals("offset")) {
            if (outStrings == null)
                outStrings = new String[max.getValue()];
            int of = ((ConstSFInt32) e.getValue()).getValue();
            if (of > 0 && of < (count.getValue() - max.getValue())) {
                if (ofs != of) {
                    for(int i = of; i < max.getValue() + of; i++)
                       outStrings[i - of] = inStrings[i];
                    outString.setValue(outStrings);
                }
                ofs = of;
            }
        }
    }
}
